# sisendi korrektsuse kontrollija

import sys

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')

n, k = [int(_) for _ in fi.readline().split()]
if 3 > n or n > 10**4:
	sys.exit('N out of range')
if 1 > k or k > 3*10**8:
	sys.exit('K out of range')
fo.write('{0} {1}\n'.format(n, k))

aa = [int(a) for a in fi.readline().split()]
srt = True
for i, a in enumerate(aa):
	if 0 > a or a > 10**8:
		sys.exit(f'A[{1 + i}] out of range')
	if i > 0 and aa[i - 1] > aa[i]:
		srt = False
fo.write('{0}\n'.format(' '.join([str(a) for a in aa])))

fi.close()
fo.close()

if len(sys.argv) > 3 and sys.argv[3] == '-v':
	if n <= 100:
		print('subtask 1')
	elif srt:
		print('subtask 2')
	else:
		print('subtask 3')
