// efektiivne lahendus, proovib läbi kõik i1 variandid ja
// iga võimaliku i1 kohta otsib võimalusi kahe ülejäänud
// auhinnaga ülejäänud summa kokku saada; selleks alustab
// indeksiga i2 järjestatud jada vasakust ja indeksiga i3
// paremast otsast; alati kui auhindade i2 ja i3 summa on
// liiga väike, suurendab i2 väärtust ja kui nende summa on
// liiga suur, vähendab i3 väärtust; selliseks proovimiseks
// kulub iga i1 väärtuse korral n sammu ja kõigi võimalike
// i1 väärtuste peale kokku seega n^2 sammu

#include <iostream>
#include <vector>
#include <algorithm>

int main() {
	int n, k;
	std::cin >> n >> k;

	std::vector<int> aa(n);
	for (auto & a : aa) {
		std::cin >> a;
	}

	std::sort(std::begin(aa), std::end(aa));

	bool ok = false;
	for (int i1 = 0; i1 < n; ++i1) {
		int i2 = i1 + 1, i3 = n - 1;
		while (i2 < i3) {
			if (aa[i1] + aa[i2] + aa[i3] < k) {
				++i2;
			} else if (aa[i1] + aa[i2] + aa[i3] > k) {
				--i3;
			} else {
				ok = true;
				break;
			}
		}
	}

	if (ok) {
		std::cout << "JAH\n";
	} else {
		std::cout << "EI\n";
	}
}
