# -- coding: utf8 --

# efektiivne lahendus, proovib läbi kõik i1 variandid ja
# iga võimaliku i1 kohta otsib võimalusi kahe ülejäänud
# auhinnaga ülejäänud summa kokku saada; selleks alustab
# indeksiga i2 järjestatud jada vasakust ja indeksiga i3
# paremast otsast; alati kui auhidade i2 ja i3 summa on
# liiga väike, suurendab i2 väärtust ja kui nende summa on
# liiga suur, vähendab i3 väärtust; selliseks proovimiseks
# kulub iga i1 väärtuse korral n sammu ja kõigi võimalike
# i1 väärtuste peale kokku seega n^2 sammu

n, k = [int(i) for i in input().split()]
a = [int(i) for i in input().split()]

a.sort()

ok = False
for i1 in range(n):
	i2, i3 = i1 + 1, n - 1
	while i2 < i3:
		if a[i1] + a[i2] + a[i3] < k:
			i2 += 1
		elif a[i1] + a[i2] + a[i3] > k:
			i3 -= 1
		else:
			ok = True
			break

if ok:
	print('JAH')
else:
	print('EI')
