// naiivne lahendus, proovib läbi kõik kolmikud i1<i2<i3
// kontrollib iga kolmiku kohta, kas need annavad õige summa
// kokku kulutab n=100 korral umbes 10^6 operatsiooni, mis
// on piisavalt kiire, ja n=10000 korral umbes 10^12, mis
// on kindlasti liiga aeglane

#include <iostream>
#include <vector>

int main() {
	int n, k;
	std::cin >> n >> k;

	std::vector<int> aa(n);
	for (auto & a : aa) {
		std::cin >> a;
	}

	bool ok = false;
	for (int i1 = 0; i1 < n; ++i1) {
		for (int i2 = 0; i2 < i1; ++i2) {
			for (int i3 = 0; i3 < i2; ++i3) {
				if (aa[i1] + aa[i2] + aa[i3] == k) {
					ok = true;
				}
			}
		}
	}

	if (ok) {
		std::cout << "JAH\n";
	} else {
		std::cout << "EI\n";
	}
}
