// efektiivne lahendus dünaamilise plaanimise meetodiga

#include <iostream>
#include <vector>
using namespace std;

int main() {
	int k, x, y;
	cin >> k >> x >> y;

	vector<int> t(k + 1); // t[i] on i koti tassimise minimaalne ajakulu
	vector<int> m(k + 1); // m[i] näitab, mitu kotti peaks esimesse koormasse võtma
	for (int i = 1; i <= k; ++i) {
		for (int j = 1; j <= i; ++j) { // vaatame kõiki esimese koorma võimalusi
			if (j > 30) break; // see ei saa õige vastus olla, aga astendamisel tekiks ületäitumine
			int v = (1 << j) - 1; // j koti kätte võtmise ajakulu
			int w = (x + j * y) + x; // j koti ära viimise ja tagasi tulemise ajakulu
			int u = v + w + t[i - j]; // kokku ajakulu, kui viime esimese koormaga j kotti
			if (j == 1 or t[i] > u) { // see on uus parim plaan
				t[i] = u;
				m[i] = j;
			}
		}
	}

	// kogume kokku optimaalse plaani kirjelduse
	vector<int> v;
	for (int i = k; i > 0; i -= m[i]) {
		v.push_back(m[i]);
	}

	cout << t[k] - x << '\n'; // viimasel korral pole vaja tagasi tulla
	cout << v.size() << '\n';
	for (unsigned i = 0; i < v.size(); ++i) {
		if (i > 0) cout << ' ';
		cout << v[i];
	}
}
