# sisendi korrektsuse kontrollija

import sys

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')

t = int(fi.readline().strip())
if 1 > t or t > 100:
	sys.exit('T out of range')
fo.write('{0}\n'.format(t))

maxn = 0
sumn = 0
maxe = 0
maxl = 0
uniq = True
for k in range(t):
	n = int(fi.readline().strip())
	if 1 > n or n > 2*10**5:
		sys.exit(f'N[{1 + k}] out of range')
	fo.write('{0}\n'.format(n))
	maxn = max(maxn, n)
	sumn += n

	ee, ll = [], []
	for i in range(n):
		e, l = [int(_) for _ in fi.readline().split()]
		if 0 > e or e > 10**9:
			sys.exit(f'E[{1 + i}] out of range')
		if 0 > l or l > 10**9:
			sys.exit(f'L[{1 + i}] out of range')
		ee.append(e)
		ll.append(l)
		fo.write('{0} {1}\n'.format(e, l))
	maxe = max(maxe, max(ee))
	maxl = max(maxl, max(ll))
	if len(set(ee)) < len(ee) or len(set(ll)) < len(ll):
		uniq = False
if sumn > 2*10**5:
	sys.exit('Sum of N out of range')

fi.close()
fo.close()

if len(sys.argv) > 3 and sys.argv[3] == '-v':
	if maxl == 0:
		print('subtask 1')
	if maxn <= 10 and uniq:
		print('subtask 2')
	if maxn <= 10:
		print('subtask 3')
	if maxl <= 1:
		print('subtask 4')
	if sumn <= 1000 and maxe <= 99 and maxl <= 99:
		print('subtask 5')
	if sumn <= 1000:
		print('subtask 6')
	print('subtask 7')
