// lahendus, mis kasutab Fenwicki puud

#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cstring>
using namespace std;

const int mx = 2e5, mod = 1e9+7;
int bit[mx+1], n;

void upd (int x, int val) {
    for (; x<=n; x+=x&(-x))
        bit[x] = (bit[x]+val)%mod;
}

int qry (int x) {
    int sum = 0;
	for (; x>0; x-=x&(-x))
        sum = (sum+bit[x])%mod;
    return sum;
}

int main() {
	int T; cin >> T;
	while (T--) {
		cin >> n;

		vector<int> X(n), Y(n);
		set<int> hulk;
		for (int i = 0; i < n; ++i) {
			cin >> X[i] >> Y[i];
			hulk.insert(X[i]);
		}

		int id = 0;
		map<int,int> uus_X;
		for (int el : hulk)
			uus_X[el] = ++id;

		set<pair<int,int>, greater<pair<int,int>>> opilased;

		for (int i = 0; i < n; ++i)
			opilased.insert({Y[i], uus_X[X[i]]});

		int vastus = 0;
		for (auto [y, x] : opilased) {
			int v = (qry(x-1)+1)%mod;
			upd (x, v);
			vastus = (vastus+v)%mod;
		}

		cout << vastus << "\n";
		memset(bit, 0, 4*(n+1));
	}

	return 0;
}
