# sisendi korrektsuse kontrollija

import sys

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')

n, m, k = [int(_) for _ in fi.readline().split()]
if 1 > n or n > 10**5:
	sys.exit('N out of range')
if 1 > m or m > 10**5:
	sys.exit('M out of range')
if 1 > k or k > 10**5:
	sys.exit('K out of range')
fo.write('{0} {1} {2}\n'.format(n, m, k))

sums = 0
for i in range(m):
	ss = [int(s) for s in fi.readline().split()]
	if 1 > ss[0] or ss[0] > n:
		sys.exit(f'S[{1 + i}] out of range')
	tt = ss[1:]
	if len(tt) != ss[0]:
		sys.exit(f'T[{1 + i}] length mismatch')
	if 1 > min(tt) or max(tt) > n:
		sys.exit(f'T[{1 + i}] values out of range')
	if len(set(tt)) != ss[0]:
		sys.exit(f'T[{1 + i}] values not distinct')
	fo.write('{0}\n'.format(' '.join([str(s) for s in ss])))
	sums += ss[0]
if sums > 200000:
	sys.exit(f'Sum of S[i] out of range')

for i in range(k):
	u = int(fi.readline().strip())
	if 1 > u or u > n:
		sys.exit(f'U[{1 + i}] out of range')
	fo.write('{0}\n'.format(u))

fi.close()
fo.close()

if len(sys.argv) > 3 and sys.argv[3] == '-v':
	if n <= 100 and m <= 100 and k == 1:
		print('subtask 1')
	elif n <= 100 and m <= 100 and k <= 100:
		print('subtask 2')
	elif n <= 1000 and m <= 1000 and k <= 1000:
		print('subtask 3')
	else:
		print('subtask 4')
