# täislahendus kasutades DSU'd

N, M, K = map(int, input().split())

parent = [i for i in range(N+1)]
size = [1 for _ in range(N+1)]

def find(x: int):
    if parent[x] == x: return x
    parent[x] = find(parent[x])
    return parent[x]

def merge(u: int, v: int):
    u = find(u)
    v = find(v)
    if u == v: return
    if size[v] > size[u]: u, v = v, u
    parent[v] = u
    size[u] += size[v]

for i in range(M):
    _, *Si = map(int, input().split())
    for a,b in zip(Si, Si[1:]):
        merge(a, b)

for i in range(K):
    x = int(input())
    print(size[find(x)])

