
from collections import defaultdict

n = int(input())

rs = []
for _ in range(n):
    x, y, w, h = tuple(map(int, input().split()))
    # "decompose" higher rectangles
    for cy in range(y, y + h):
        rs.append((x, cy, w, 1, cy == y, cy == y + h - 1))

# (x)
rs.sort(key=lambda r: r[0])

yc = defaultdict(int)
l = 0
for x, y, w, h, u, d in rs:
    if yc[y] == x:
        l += 1
    yc[y] = x + w
    if u and yc[y - 1] > x:
        l += min(yc[y - 1], x + w) - x
    if d and yc[y + 1] > x:
        l += min(yc[y + 1], x + w) - x
    
print(l)
