# -- coding: utf8 --

# efektiivne lahendus dünaamilise plaanimise meetodiga

k, x, y = map(int, input().split())

t = [0] * (k + 1) # t[i] on i koti tassimise minimaalne ajakulu
m = [0] * (k + 1) # m[i] näitab, mitu kotti peaks esimesse koormasse võtma
for i in range(1, k + 1):
	for j in range(1, i + 1): # vaatame kõiki esimese koorma võimalusi
		v = 2**j - 1 # j koti kätte võtmise ajakulu
		w = (x + j * y) + x # j koti ära viimise ja tagasi tulemise ajakulu
		u = v + w + t[i - j] # kokku ajakulu, kui viime esimese koormaga j kotti
		if j == 1 or t[i] > u: # see on uus parim plaan
			t[i] = u
			m[i] = j

# kogume kokku optimaalse plaani kirjelduse
v = []
i = k
while i > 0:
	v.append(m[i])
	i -= m[i]

print(t[k] - x) # viimasel korral pole vaja tagasi tulla
print(len(v))
print(*v)
