#include <iostream>
#include <vector>
#include <set>
#include <map>
using namespace std;

const int mod = 1e9+7;

int main() {
	int T; cin >> T;
	while (T--) {
		int n; cin >> n;

		vector<int> X(n), Y(n);
		set<int> hulk;
		for (int i = 0; i < n; ++i) {
			cin >> X[i] >> Y[i];
			hulk.insert(X[i]);
		}

		int id = 0;
		map<int,int> uus_X;
		for (int el : hulk)
			uus_X[el] = ++id;

		set<pair<int,int>, greater<pair<int,int>>> opilased;

		for (int i = 0; i < n; ++i)
			opilased.insert({Y[i], uus_X[X[i]]});

		vector<int> dp(n+1,0);

		for (auto [y, x] : opilased) {
			int sum = 1;
			for (int x2 = 1; x2 < x; ++x2)
				sum = (sum+dp[x2])%mod;
			dp[x] = (dp[x]+sum)%mod;
		}

		int vastus = 0;
		for (int x = 1; x <= n; ++x)
			vastus = (vastus+dp[x])%mod;

		cout << vastus << "\n";
	}

	return 0;
}

